package com.gic.enterprise.dao.mapper;

import com.gic.enterprise.entity.TabTableSetting;
import com.github.pagehelper.Page;
import org.apache.ibatis.annotations.Param;
/**
 * 增删改查自动生成配置
 * @ClassName:
 * @Description:  
 * @author guojuxing 
 * @date 2021/7/27 10:02 AM 
 */
public interface TabTableSettingMapper {
    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabTableSetting record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabTableSetting record);

    /**
     * 根据主键查询
     *
     * @param tableId 主键
     * @return 实体对象
     */
    TabTableSetting selectByPrimaryKey(Integer tableId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabTableSetting record);

    /**
     * 根据主键更新记录，包括二进制大对象
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeyWithBLOBs(TabTableSetting record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabTableSetting record);


    /**
     * 操作
     * @param search
     * @return
     */
    Page<TabTableSetting> pageTableSetting(@Param("search") String search);

    /**
     * 操作
     * @param tableName
     * @return
     */
    TabTableSetting getTableSettingByTableName(@Param("tableName") String tableName);
}