package com.gic.enterprise.service.impl;

import com.gic.commons.util.EntityUtil;
import com.gic.enterprise.constant.FieldTypeEnum;
import com.gic.enterprise.dao.mapper.TabTableSettingFieldMapper;
import com.gic.enterprise.dto.TableSettingFieldDTO;
import com.gic.enterprise.entity.TabTableSettingField;
import com.gic.enterprise.service.TableSettingFieldService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
/**
 * 增删改查自动生成配置
 * @ClassName:
 * @Description:  
 * @author guojuxing 
 * @date 2021/7/27 10:02 AM 
 */
@Service
public class TableSettingFieldServiceImpl implements TableSettingFieldService {
    @Autowired
    private TabTableSettingFieldMapper tabTableSettingFieldMapper;

    @Override
    public String saveTableField(TableSettingFieldDTO tableSettingFieldDTO) {
        TabTableSettingField tab = EntityUtil.changeEntityByJSON(TabTableSettingField.class, tableSettingFieldDTO);
        Date date = new Date();
        tab.setUpdateTime(date);
        TabTableSettingField field = tabTableSettingFieldMapper.getFieldByKey(tab.getTableId(), tab.getFieldKey());
        if(tab.getFieldId() != null){
            if(field != null){
                if(!field.getFieldId().equals(tab.getFieldId())){
                    return "该字段已经存在";
                }
            }
            tabTableSettingFieldMapper.updateByPrimaryKeySelective(tab);
        } else {
            if(field != null){
                return "该字段已经存在";
            }
            tab.setCreateTime(date);
            tabTableSettingFieldMapper.insertSelective(tab);
        }
        return null;
    }

    @Override
    public List<TableSettingFieldDTO> listTableField(Integer tableId) {
        List<TabTableSettingField> list = tabTableSettingFieldMapper.listField(tableId);
        return EntityUtil.changeEntityListByJSON(TableSettingFieldDTO.class, list);
    }

    @Override
    public void delTableField(Integer fieldId) {
        TabTableSettingField field = tabTableSettingFieldMapper.selectByPrimaryKey(fieldId);
        if(field == null){
            return;
        }
        boolean isContainIdKey = "id".equals(field.getFieldKey());
        if(isContainIdKey){
            return;
        }
        field.setFieldId(fieldId);
        field.setDeleteFlag(1);
        tabTableSettingFieldMapper.updateByPrimaryKeySelective(field);
    }
}
